;--------------------- Resolving endianness resolving routines ----------------

(provide 'endian)
(require 'langc)

(define *LITTLE-ENDIAN* 1234) ; like 6502, 8088, i386
(define *BIG-ENDIAN*	4321) ; like 6800, 68000, Sparc, network


(define endian:4-1234->4321,swap-4-bytes)
(define endian:4-4321->1234,swap-4-bytes)
(define endian:4-1234->1234,id)
(define endian:4-4321->4321,id)
(define endian:2-1234->4321,swap-2-bytes)
(define endian:2-4321->1234,swap-2-bytes)
(define endian:2-1234->1234,id)
(define endian:2-4321->4321,id)


(C:define-func 'uint32 'swap-4-bytes '((x uint32))
    '(C:declare-variables
       (C:union (u32 uint32) (u8 (C:array 4 uint8))) X Y)
    '(C:set! (C:select X u32) x)
    '(C:set! (C:arry-ref (C:select Y u8) 0) (C:arry-ref (C:select X u8) 3))
    '(C:set! (C:arry-ref (C:select Y u8) 1) (C:arry-ref (C:select X u8) 2))
    '(C:set! (C:arry-ref (C:select Y u8) 2) (C:arry-ref (C:select X u8) 1))
    '(C:set! (C:arry-ref (C:select Y u8) 3) (C:arry-ref (C:select X u8) 0))
    '(C:return (C:select Y u32)))

(C:attribute 'swap-4-bytes 'static 'inline)

(C:define-func 'uint16 'swap-2-bytes '((x uint16))
    '(C:declare-variables
       (C:union (u16 uint16) (u8 (C:array 2 uint8))) X Y)
    '(C:set! (C:select X u16) x)
    '(C:set! (C:arry-ref (C:select Y u8) 0) (C:arry-ref (C:select X u8) 1))
    '(C:set! (C:arry-ref (C:select Y u8) 1) (C:arry-ref (C:select X u8) 0))
    '(C:return (C:select Y u16)))

(C:attribute 'swap-2-bytes 'static 'inline)
