;------------- Linux specific definitions for the OTOP subproject -------------

(provide 'linux)

;------ System "C" header files. ------

;--- Standard C Headers:

(define (C:STD-INCLUDES)
  ((C:include 'stdio)
   (C:include 'stdlib)
   (C:include 'string)
   (C:include 'stdarg)))

;--- OS-specific I/O
(define LLL-OS 'Linux)
(define (C-OS-INCLUDES)
   (C:include 'unistd)
   (C:include 'fcntl)
   (C:include 'errno))

;--- Low-level TTY I/O
(define LLL-TTYIO 'termios)
(define (C-TTY-INCLUDES)
   (C:include 'termios))

;--- Network subsystem




; Text/Graphical User interface stuff below should really belong to
; other configuration files, eg. svgalib.scm, x11.scm, etc, that autoconf
; should define.

;--- video text array
(define LLL-VIDEOTEXT 'ncurses)
(define (C-VIDEOTEXT-INCLUDES)
   (C:include 'curses))

;--- Hi-Res Video
;We should let the user choose between NCURSES, SVGALIB and/or X11 at
;compile-time or better, runtime.

(define (C-VIDEO-INCLUDES)
   (cond
     (USES-SVGALIB
        (C:include 'vga))
     (USES-X11
        (C:include 'X11/Xlib))))
