; default.scm


(provide 'defaults)

; needs be translated from m4...


(define (vp:name name Cname LLLname)
   (or Cname name))


; --- Branching & Loops ---

"
(ifdef Ifcompare
   (define Branch Ifcompare($1 $2 $3 Goto($4))))
ifdef(Branch 
   (define Ifcompare 
      pushdef(elsetarget newlabel)
       pushdef(exittarget newlabel)
         Branch(negcond($1) $2 $3 elsetarget)
	 $4
	 ifelse($5   Goto(exittarget))
	elsetarget:
	 ifelse($5   $5)
	exittarget:
       popdef(elsetarget)
       popdef(exittarget)
))dnl Ifcompare(cond arg1 arg2 ifclause opt elseclause)

(define Repeat 
      pushdef(repeattarget newlabel)
       pushdef(exittarget newlabel)
	repeattarget:
	 $1
	 Branch($2 $3 $4 repeattarget)
	exittarget:
       popdef(repeattarget)
       popdef(exittarget)
)dnl Repeat(repeatclause cond arg1 arg2) continues *while* cond is true
(define While 
      pushdef(whiletarget newlabel)
	Goto(whiletarget)
	Repeat($5
	whiletarget: $1 $2 $3 $4)
       popdef(whiletarget)
)dnl While(compcond cond arg1 arg2 whileclause) continues *while* cond is true
(define Loop While( nz COUNT 0 __Seq__($1 Dec(COUNT))))
(define Loopno0 Repeat(__Seq__($1 Dec(COUNT)) nz COUNT 0))



; --- Register Convention ---

;DSINC: data stack increment
;DSP: data stack pointer
;DSE(n): data stack element (n)

;RSINC: return stack increment

(define (DSE n) (point DSP $1))
(define (NOS) (DSE 0))
(define (TSE) (DSE 1))
(define (FSE) (DSE 2))
(define (Nip* x) (AddIm DSP (* MDSINC x)))
(define (Pin* x) (AddIm DSP (* DSINC x)))
(define PopmData  __Seq__(Mov(TOS DSE(ifelse($1  0 $1-1))) 
				Nip($1)))
(define PopData  __Seq__(Mov($1 TOS) Mov(TOS NOS) Nip))
(define PushData __Seq__(Pin Mov(NOS TOS) Mov(TOS $1)))
(define RSE point(RSP $1))
(define (TORS) (RSE 0))
(define (NORS) (RSE 1))
(define DropReturn AddIm(RSP ifelse($1  MRSINC $1*MRSINC)))
(define PordReturn AddIm(RSP ifelse($1  RSINC $1*RSINC)))
(define PopmReturn  __Seq__(Mov(TOS RSE(ifelse($1  0 $1))) 
				DropReturn($1)))
(define PopReturn  __Seq__(Mov($1 RSE(0)) DropReturn))
(define PushReturn __Seq__(ProdReturn Mov(RSE(0) $1)))


; --- Calling Convention ---

(define (*Enter* x) (AddIm PC $1))
(define Enter ifelse($# 0 _Enter_(PCINC) 
		Mov($1 point(PC PCINC))
		 _Enter_(2*PCINC)))
(define Next Goto(point(PC)))
(define Call_LLL 
irp(X reverse(shift($@)) PushData(X))
local(Sequel T1 
PushReturn(PC)
Call(T1)
T1:
AddIm(point(RSP) ival(pval(Sequel)-pval(T1)))
Mov(PC RSP)
AddIm(PC RSINC)
Goto($1)
Sequel:
PopReturn(PC)
))
"

; --- Defining a FORTH word ---

"
  * to define a FORTH word 
  * ....
  * add an entry in a m4 table  so that we can later
    simulate FORTH compilation from within m4 
    provided the only meta-words used were built into the m4 files...
 ......
"

"
;(define (Label x) (OSLK_ x))
(define DefSymbol 
__symbolseg__(
   defcell(StringAddress($1))dnl	the name string
   defcell(SymbolFlags($2))dnl		flags
   defcell(SymbolValue($3))dnl		pointer to the value
))

define(__DefWord__ 
pushdef(FWLABEL Label($2))
DefString(DefSymbol(strbeg $3 FWLABEL) $1)
FWLABEL:
popdef(FWLABEL)
)
define(__DefAlias__ 
DefString(DefSymbol(strbeg $3 Label($4)) $1)
Equate(Label($2) Label($4))
)
"

(define (DefWord name Cn Ln . x)
   (apply **DefWord (append (list name (or Cn name) (or Ln name)) x)))
(define (DefAlias name Cn Ln . x)
   (apply **DefAlias (append (list name (or Cn name) (or Ln name)) x)))

; --- Constant values ---
(define TRUE -1)	;Logical True value
(define FALSE 0)	;Logical False value


; --- Deduced values ---

(define CHARSIZE (<< 1 CHARABITS))	;size of a char in bytes
(define WORDSIZE (<< 1 WORDABITS))	;size of a char in bytes
(define CELLSIZE (<< 1 CELLABITS))	;size of a cell in bytes
(define PAGESIZE (<< 1 PAGEABITS))	;size of a page in bytes
(define CHARMASK (- CHARSIZE))		;mask of char pointer
(define WORDMASK (- WORDSIZE))		;mask of word pointer
(define CELLMASK (- CELLSIZE))		;mask of cell pointer
(define PAGEMASK (- PAGESIZE))		;make of page pointer
(define BITSPERCHAR (* CHARSIZE BYTEBITS))	;bits in a char
(define BITSPERCELL (* CELLSIZE BYTEBITS))	;bits in a cell
